// WPLOTCMD.H - C Header file for DLL used to send commands & data to WPlot.
// Hooks to these functions will be linked to the users program if the
// import library file WPLOTCMD.LIB is specified in the project file or
// if the following code is included in the program's DEF file:
// IMPORTS  WPLOTCMD.StartWPlot
//          WPLOTCMD.WPlotcmd

int FAR PASCAL _export StartWPlot( int id, char far *path );
// Starts WPlot with parameter "#n" where n is a specified buffer id (1 to 4).
// The id allows up to 4 different instances of WPlot to be controlled.
// The path to WPlot is specified by the second parameter (may be NULL).
// If the path specifies a directory then it must be followed by a "\".
// Returns 0 if successfull, else one of the following error codes:
// 1: Out of memory, 2: Invalid id, 3: File not found, 4: Path not found
// 5 or greater: unspecified error.

int FAR PASCAL _export WPlotcmd( int id, char far *pcmd, int nocheck );
// Puts command pointed to by pcmd into internal buffer associated with id if
// the buffer is empty.  Returns 0 if successfull; returns 1 if the buffer is
// not empty, i.e. the buffer has not yet been read by WPlot.  The test for
// an empty buffer is disabled if nocheck is nonzero.  WPlotcmd can be called
// with pcmd = NULL (and nocheck = 0) to just check that the buffer is empty.
// NOTE:  The WPlotcmd function calls PeekMessage to make sure WPlot had a
// chance to read the previous command.

void FAR PASCAL _export getcmd( int id, char far *pcmd, int maxc );
// Copies command from internal buffer associated with id to pcmd;
// a maximum of maxc characters will be copied (including null char).
// Just the null character is copied if the buffer is empty.  This is the
// function that WPlot uses to read a command; it is not needed by the user.

